import { either } from './either'

test('with multiple inputs', () => {
  const between = function(a, b, c){ return a < b && b < c }
  const total20 = function(a, b, c){ return a + b + c === 20 }
  const fn = either(between, total20)
  expect(fn(7, 8, 5)).toBeTruthy()
})

test('skip evaluation of the second expression', () => {
  let effect = 'not evaluated'
  const F = function(){ return true }
  const Z = function(){ effect = 'Z got evaluated' }
  either(F, Z)()

  expect(effect).toBe('not evaluated')
})

test('1', () => {
  const firstFn = val => val > 0
  const secondFn = val => val * 5 > 10

  expect(either(firstFn, secondFn)(1)).toBeTruthy()
})

test('2', () => {
  const firstFn = val => val > 0
  const secondFn = val => val === -10
  const fn = either(firstFn)(secondFn)

  expect(fn(-10)).toBeTruthy()
})
